import java.awt.*;
import java.awt.image.*;
import java.applet.Applet;

public class PixelBuffer{
	MemoryImageSource memoryImageSource;
	Image image;
	int[] pixels;
	int height,width,length;
	int redC,greenC,blueC;

	public PixelBuffer(int w,int h,Applet a){
		length=w*h;
		pixels=new int[w*h];
		for(int j=0;j<length;++j)pixels[j]=0xFF000000;    
		memoryImageSource=new MemoryImageSource(w,h,pixels,0,w);
		memoryImageSource.setAnimated(true);
		image=a.createImage(memoryImageSource);
		width=w;
		height=h;
		setColor(0);
	}
	public Image getImage(){
		return image;
	}
	public void  flushBuffer(){   
		memoryImageSource.newPixels(0,0,width,height);
	}
	public void fadeBuffer(){
		int color;
		for(int j=0;j<pixels.length;++j){
			int c=pixels[j];
			int r=(c & 0xff0000)-0x050000;
			if((r>>16)<0)r=0;
			int g=(c&0xff00)-0x000500;
			if((g>>8)<0)g=0;
			int b=(c&0xff)-0x000005;
			if((b<0))b=0;
			pixels[j]=0xff000000|r|g|b;
		}
	}
	public void setPixel(int x,int y,int c){
		pixels[x*height + y]|=c;
	}
	public void setSquare(int x, int y, int myWidth, int myHeight, int c){
		
		int h = x + myWidth;
		int j = y + myHeight;
			
		for(int k=x; k < h; k++){
			for(int l=y; l < j; l++){
				if((k > 0 && k < width ) && ( l > 0 && l < height)){
					setPixel(l,k,c);
				}
			}
		}
	}
	public int getPixel(int x,int y){
		return pixels[x*height+y];
	}
	public void filter(){
		int m=1,n=1,widthMinusOne=width-1,heightMinusOne=height-2,w=width,os=width;
		for(m=1;m<height-2;++m){
			++os;
			for(n=1;n<width-2;++n){
				int a=pixels[os-w-1];
				int b=pixels[os-w];
				int c=pixels[os-w+1];
				int d=pixels[os-1];
				int e=pixels[os]*0;
				int f=pixels[os+1];
				int g=pixels[os+w-1];
				int h=pixels[os+w]*0;
				int i=pixels[os+w+1];
				int red=0xFF0000&(((a&0xff0000)+(b&0xff0000)+(c&0xff0000)+(d&0xff0000)+(e&0xff0000)+(f&0xff0000)+(g&0xff0000)+(h&0xff0000)+(i&0xff0000))/7);
				red-=redC;
				if(red<0)red=0;
				if(red>0xff0000)red=0xff0000;
				int green=0xff00&(((a&0xff00)+(b&0xff00)+(c&0xff00)+(d&0xff00)+(e&0xff00)+(f&0xff00)+(g&0xff00)+(h&0xff00)+(i&0xff00))/7);
				green-=greenC;
				if(green<0)green=0;
				if(green>0xff00)green=0xff00;
				int blue=0xff&(((a&0xff)+(b&0xff)+(c&0xff)+(d&0xff)+(e&0xff)+(f&0xff)+(g&0xff)+(h&0xff)+(i&0xff))/7);
				blue-=blueC;
				if(blue<0)blue=0;
				if(blue>0xff)blue=0xff;
				pixels[os]=0xff000000|red|green|blue;
				++os;
			}
			++os;
			++os;
		}
	} 
	public void setColor(int c){
		if(c==0){
			redC=0;
			greenC=0x00000500;
			blueC=0x0000000F;
			return;
		}
		if(c==1){
			redC=0x00050000;
			greenC=0;
			blueC=0x0000000F;
			return;
		}
		if(c==2){
			redC=0x00050000;
			greenC=0x00000F00;
			blueC=0;
			return;
		}
		if(c==3){
			redC=0;
			greenC=0x00000F00;
			blueC=0x00000005;
			return;
		}
		if(c==4){
			redC=0x000F0000;
			greenC=0;
			blueC=0x00000005;
			return;
		}
		if(c==5){
			redC=0x000F0000;
			greenC=0x00000500;
			blueC=0;
			return;
		}
	}
}
   