import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.Font;
import java.awt.Event;
import java.applet.Applet;

public class Test3 extends Applet implements Runnable{
	Image offscreenImg;
	Thread runner;
	Graphics offscreenG;
	Graphics gr;
	Font tempFont;
	int windowPadding;
	Color tmpColor;
	particle point1, point2;
	PixelBuffer pb;
	keyboardJ currentKeyboard;
	double Tangent[];
	
	int xborder, yborder, delay;
	
	game tankGame;
	
	public void init(){
		Tangent = new double[361];
		
		double tmpCon =  Math.PI/180;
		
		for(int j=0; j< 361; j++){
			Tangent[j] = Math.tan(j * tmpCon);	
		}
		
		delay = 10;
		
		windowPadding = 3;
		
		//Find applet border
		xborder = size().width;
		yborder = size().height;
		
		// Create Image & Graphic type variables for buffering animation.
		offscreenImg = createImage(xborder, yborder);
		offscreenG = offscreenImg.getGraphics();
		
		pb = new PixelBuffer(xborder, yborder, this);
		
		//Create game
		tankGame = new game(this);
		//Initialize game parts
		tankGame.initEnemies(1,1);
		tankGame.initPlayer(1);
		tankGame.initProjectiles(20,3);
		tankGame.initWindows(6);
		tankGame.initExplosionParticles(100);
		
		//Add enemies
		for(int i=0; i < 2; i ++){
			tankGame.addEnemy(100,100,0,10,10,180, 75, 12);
			
		}
		
		//Add enemy images
		tankGame.addEnemyImage(getImage(getDocumentBase(),"swordfish2.gif"), 0);
				
		//Add player
		tankGame.addPlayer(xborder/2 - 43, yborder-25, 10, 2, 0, 4, 100, 86,33, 3);		
		
		//Add player images
		tankGame.addPlayerImage(getImage(getDocumentBase(),"tank2.gif"), 0);
		
		//Add projectile images
		tankGame.addProjectileImage(getImage(getDocumentBase(), "cannonball3.gif"), 1);
		tankGame.addProjectileImage(getImage(getDocumentBase(), "bomb2.gif"), 2);
		
		//Add windows
		tempFont = new Font("DialogInput", Font.BOLD, 10);
		tankGame.addWindow(5, 10, tempFont, Color.white, "Console");
		tempFont = new Font("Helvetica", Font.BOLD, 15);
		tankGame.addWindow(145, yborder/2, tempFont, Color.red, "Main");
		tempFont = new Font("Helvetica", Font.BOLD, 12);
		tankGame.addWindow(0, yborder - 25, tempFont, Color.white, "StatusBar", getImage(getDocumentBase(), "concretebar.gif"));
		tankGame.addWindow(5, yborder - 6, tempFont, Color.white, "statsArmor", Color.black, 65, 15);
		tankGame.addWindow(80, yborder - 6, tempFont, Color.white, "statsAngle", Color.black, 65, 15);
		tankGame.addWindow(155, yborder - 6, tempFont, Color.white, "statsScore", Color.black, 120, 15);
		
		//Define main and console windows to the game
		tankGame.setConsoleWin("Console");
		tankGame.setMainWin("Main");
		
		//Create the barrel
		point1 = new particle((tankGame.getPlayerX() + tankGame.getPlayerWidth()/2)+10, yborder - tankGame.getPlayerHeight()/2);
		point2 = new particle(tankGame.getPlayerX() + (tankGame.getPlayerWidth()+3), yborder - tankGame.getPlayerHeight()/2);
		point1.theta = 0;
		point2.theta = 0;
		
		//Create the keyboard
		currentKeyboard = new keyboardJ(6);
		currentKeyboard.addKey("Up", Event.UP);
		currentKeyboard.addKey("Down", Event.DOWN);
		currentKeyboard.addKey("Left", Event.LEFT);
		currentKeyboard.addKey("Right", Event.RIGHT);
		currentKeyboard.addKey("Fire", Event.ENTER);
		currentKeyboard.addKey("Tab", Event.TAB);
		
	}
	public void start(){
		if (runner == null){
			runner = new Thread(this);
			runner.start();
		}
	}
	
	public void stop(){
		if (runner != null){
			runner.stop();
			runner = null;			
		}
	}
	
	public void run(){
		
		while (true){
			if(tankGame.gameLoaded){
				repaint();
				switch (tankGame.gameState){
				case 1: //Game is in a state of game over
					tankGame.addWindowMessage("Main", "Game Over", 2);
					tankGame.addWindowMessage("Console", "Press Tab to start the game.", 2);
					break;
				case 2: //Game is active
					tankGame.moveUnits();
					tankGame.enemyAction();
					tankGame.checkBounds(xborder, yborder-25);
					tankGame.collisionDet();
					checkPlayer();
					tankGame.respawnUnits(xborder, yborder);
					break;
				}
				
				updateWindows();
				tankGame.age();
				handleKeyboard();
				
				try{Thread.sleep(delay);}
				catch(InterruptedException e){
					tankGame.addWindowMessage("Console", "Exception caught when trying to sleep.", 500);
				}
			}
			else{
				try{Thread.sleep(delay);}
				catch(InterruptedException e){
					tankGame.addWindowMessage("Console", "Exception caught when trying to sleep.", 500);
				}
				tankGame.addWindowMessage("Console", "Please wait while images load.", 2);
				repaint();
				tankGame.forceImageLoad();
			}
		}
		
	}	
	
	//Update stats windows
	public void updateWindows(){
		
		tankGame.addWindowMessage("StatusBar", " ", 2);
		tankGame.addWindowMessage("statsAngle", "Angle: " + Math.abs(360 - point2.theta), 2);
		tankGame.addWindowMessage("statsArmor", "Armor: " + tankGame.currentPlayer.armor, 2);
		tankGame.addWindowMessage("statsScore", "Score: " + tankGame.getScore(), 2);
	}
	
	public void checkPlayer(){
		if(tankGame.currentPlayer.armor == 0){
			tankGame.currentPlayer.respawn(xborder/2 - 43, yborder-25);
			tankGame.currentPlayer.armor = 100;
			tankGame.currentPlayer.velocity = 2;
			tankGame.addScore(-tankGame.getScore());
			tankGame.addWindowMessage("Main", "You were destroyed.", 100);
			tankGame.gameState = 1;
			tankGame.killAll();
		}	
	}
	
	// Override the update in the Graphics class to reduce flicker even more.
	public void update(Graphics g){paint(g);}
	
	public void paint(Graphics g){
	
		//Paint background
		offscreenG.setColor(Color.black);
		offscreenG.fillRect(0,0,xborder,yborder);
		
		
		if(tankGame.gameLoaded && tankGame.gameState ==2){
		
			//Paint explosion particles
			for(int i=0; i < tankGame.maxExplosionParticles; i++){
				if(tankGame.explosionPList[i].isAlive()){
					//Draw particle
					pb.setSquare( (int)tankGame.explosionPList[i].x,(int)tankGame.explosionPList[i].y, (int)tankGame.explosionPList[i].width, (int)tankGame.explosionPList[i].height, tankGame.explosionPList[i].explosionPColor.getRGB());
				}
			}
			
			pb.filter();
			pb.fadeBuffer();
			offscreenG.drawImage(pb.getImage(), 0, 0, this);
		
			//Paint projectiles
			for(int i=0; i < tankGame.maxProjectiles; i++){
				if(tankGame.projectileActive(i)){
					if(tankGame.getProjectileImageType(i) == 0){
						offscreenG.setColor(tankGame.getProjectileColor(i));
						offscreenG.fillRect((int)tankGame.getProjectileX(i),(int)tankGame.getProjectileY(i),(int)tankGame.getProjectileSizeX(i),(int)tankGame.getProjectileSizeY(i));
						//pixelBuffer.setSquare( (int)tankGame.getProjectileX(i),(int)tankGame.getProjectileY(i), (int)tankGame.getProjectileSizeX(i), (int)tankGame.getProjectileSizeY(i), tankGame.getProjectileColor(i).getRGB());
					}
					else{
						offscreenG.drawImage(tankGame.getProjectileImage(tankGame.getProjectileImageType(i)), (int)tankGame.getProjectileX(i), (int)tankGame.getProjectileY(i), this);
					
					}
				}
			}
		
			//Paint enemies
			for(int i=0; i < tankGame.maxEnemies; i++){
				if(tankGame.enemyActive(i)){
					offscreenG.drawImage(tankGame.getEnemyImage(i),(int)tankGame.getEnemyX(i), (int)tankGame.getEnemyY(i),this);
				}
			}
		
			//Paint Items
			for(int i=0; i < tankGame.maxItems; i++){
				if(tankGame.itemActive(i)){
					offscreenG.drawImage(tankGame.getItemImage(i), (int)tankGame.getItemX(i), (int)tankGame.getItemY(i), this);
				}
			}
		
			//Paint player
			offscreenG.drawImage(tankGame.getPlayerImage(tankGame.getPlayerImgType()),(int)tankGame.getPlayerX(), (int)tankGame.getPlayerY(), this);
			offscreenG.setColor(Color.red);
			point1.x = (tankGame.getPlayerX() + tankGame.getPlayerWidth()/2) + 15;
			point1.y = tankGame.getPlayerY() + tankGame.getPlayerHeight()/2;
			point2.x = tankGame.getPlayerX() + (tankGame.getPlayerWidth()+3);
			point2.y = tankGame.getPlayerY() + tankGame.getPlayerHeight()/2;
			point1.rotate((int)(tankGame.getPlayerX() + tankGame.getPlayerWidth()/2), (int)(tankGame.getPlayerY() + tankGame.getPlayerHeight()/2), point2.theta);
			point2.rotate((int)(tankGame.getPlayerX() + tankGame.getPlayerWidth()/2), (int)(tankGame.getPlayerY() + tankGame.getPlayerHeight()/2), point2.theta);
			offscreenG.drawLine((int)point2.x, (int) point2.y, (int)point1.x, (int)point1.y);
		}
		
		//Paint windows
		for(int i=0; i < tankGame.maxWindows; i++){
			if(tankGame.getWindow(i).msgLength() > 0){
				//Draw background image if one is defined
				if(tankGame.getWindow(i).bgImage != null){
					offscreenG.drawImage(tankGame.getWindow(i).bgImage, tankGame.getWindow(i).x, tankGame.getWindow(i).y, this);
				}
				
				//Draw background color is one is defined
				if(tankGame.getWindow(i).bgColor != null){
					offscreenG.setColor(tankGame.getWindow(i).bgColor);
					offscreenG.fillRect(tankGame.getWindow(i).x-windowPadding, (tankGame.getWindow(i).y-tankGame.getWindow(i).height)+windowPadding, tankGame.getWindow(i).width, tankGame.getWindow(i).height);
				}
				//Draw window messages
				offscreenG.setFont(tankGame.getWindow(i).wFont);
				offscreenG.setColor(tankGame.getWindow(i).fntColor);
				for(int j = 0; j < tankGame.getWindow(i).msgLength(); j++){
					offscreenG.drawString(tankGame.getWindow(i).getMsg(j),tankGame.getWindow(i).x,tankGame.getWindow(i).y+(15*j));
				}
			}
		}
		
		
		// Actually paint image onscreen.
		g.drawImage(offscreenImg, 0, 0, this);
		
		
		pb.flushBuffer();
		
	
	}
	
	
	public boolean keyDown(Event e, int key){
		currentKeyboard.keyDown(key);
		return true;
	}
	
	public boolean keyUp(Event e, int key){
		currentKeyboard.keyUp(key);
		return true;	
	}
	
	//Handle the keyboard
	public void handleKeyboard(){
		if(tankGame.gameState == 2){ //If the game is active accept controlling input
			if(currentKeyboard.isKeyDown("Up")){
				point2.thetaAdd(-1);
				if(point2.theta > 90 && point2.theta < 180){point2.theta = 180;}
			}
			if(currentKeyboard.isKeyDown("Down")){
				point2.thetaAdd(1);
				if(point2.theta > 0 && point2.theta < 90){point2.theta = 0;}
			}
			if(currentKeyboard.isKeyDown("Left")){
				tankGame.currentPlayer.theta = 180;
				tankGame.currentPlayer.linearMove();
			}
			if(currentKeyboard.isKeyDown("Right")){
				tankGame.currentPlayer.theta = 0;
				tankGame.currentPlayer.linearMove();
			}
		
			if(currentKeyboard.isKeyDown("Fire")){
				if(tankGame.projectilesOnScreen(4)< 4 && (tankGame.getYoungestTime(4)/1000) >= .5){
					tankGame.activateProjectile(point2.x,point2.y, 100, 1, Color.green, true, false, point2.theta, 4);
				}
			}
		}
		else{//If the game is over
			if(currentKeyboard.isKeyDown("Tab")){
					tankGame.gameState = 2; //Set the game to active
			}
		}
	}
}
