import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Component;
import java.awt.Font;
import java.awt.Color;

public class game{
	public int gameState, maxEnemies, maxEnemyImages, maxWindows, maxPlayerImages, maxProjectiles, maxProjectileImages, maxItems, maxItemImages, maxExplosionParticles;
	public enemy enemyList[];
	public Image playerImage[], enemyImage[], projectileImage[], itemImage[];
	public windowJ windowList[];
	public player currentPlayer;
	public projectile projectileList[];
	public item itemList[];
	public explosionP explosionPList[];
	
	private int currentEnemyNum, currentImages, currentEnemyImage, currentPlayerImgNum, currentWindowNum, score, currentItemNum;
	private String consoleWin, mainWin;
	private MediaTracker tracker;
	private Font tmpFont;
	public boolean gameLoaded;
	
	game(Component currentComp){//Default constructor
		//Set the game state
		this.gameState = 1;
		//Set score to zero
		this.score = 0;
		//Set MediaTracker
		this.tracker = new MediaTracker(currentComp);
		//Set current number of images loaded into game(used for media tracking)
		this.currentImages = 0;
		//Create a default font for windows
		this.tmpFont = new Font("Helvetica", Font.BOLD, 10);
		//Initialize window string names for internal use
		this.consoleWin = new String("");
		this.mainWin = new String("");
		
		this.gameLoaded = false;
	}
	
	game(int maxEnemies, int maxProjectiles, int maxEnemyImages, int maxPlayerImages, int maxProjectileImg, int maximumWindows, int maxItems, int maxItemImages, Component currentComp){//Complete Constructor
		//Set the game state
		this.gameState = 1;
		//Set score to zero
		this.score = 0;
		//Create enemy variables
		this.enemyList = new enemy[maxEnemies];
		this.maxEnemies = maxEnemies;
		this.maxEnemyImages = maxEnemyImages;
		this.enemyImage = new Image[maxEnemyImages];
		this.currentEnemyNum = 0;
		this.currentImages = 0;
		this.currentEnemyImage = 0;
		//Creat player variables
		this.maxPlayerImages = maxPlayerImages;
		this.playerImage = new Image[this.maxPlayerImages];
		this.currentPlayerImgNum = 0;
		//Set MediaTracker
		this.tracker = new MediaTracker(currentComp);
		//Create windows
		this.maxWindows = maximumWindows;
		this.currentWindowNum = 0;
		this.windowList = new windowJ[this.maxWindows];
		this.tmpFont = new Font("Helvetica", Font.BOLD, 10);
		//Create projectile variables
		this.maxProjectiles = maxProjectiles;
		this.maxProjectileImages = maxProjectileImg;
		this.projectileList = new projectile[this.maxProjectiles];
		this.projectileImage = new Image[this.maxProjectileImages];
		for(int i = 0; i < this.maxProjectiles; i++){
			this.projectileList[i] = new projectile(0,0, 1, true);
			this.projectileList[i].setSize(3.00,3.00);
			this.projectileList[i].kill();
		}
		//Create item variables
		this.maxItems = maxItems;
		this.maxItemImages = maxItemImages;
		this.itemList = new item[this.maxItems];
		this.itemImage = new Image[this.maxItemImages];
		this.currentItemNum = 0;
		
		this.gameLoaded = false;
		
	}
	
	//____________Begin Init Methods_______________
	public void initEnemies(int maxEnemies,int maxEnemyImages){//Method to initialize enemy variables
		//Create enemy variables
		this.enemyList = new enemy[maxEnemies];
		this.maxEnemies = maxEnemies;
		this.maxEnemyImages = maxEnemyImages;
		this.enemyImage = new Image[maxEnemyImages];
		this.currentEnemyNum = 0;
		this.currentEnemyImage = 0;
	}
	
	public void initPlayer(int maxPlayerImages){//Method for initializing player variables
		//Creat player variables
		this.maxPlayerImages = maxPlayerImages;
		this.playerImage = new Image[this.maxPlayerImages];
		this.currentPlayerImgNum = 0;
	}
	
	public void initProjectiles(int maxProjectiles, int maxProjectileImg){//Method for initializing projectile variables
		//Create projectile variables
		this.maxProjectiles = maxProjectiles;
		this.maxProjectileImages = maxProjectileImg;
		this.projectileList = new projectile[this.maxProjectiles];
		this.projectileImage = new Image[this.maxProjectileImages];
		for(int i = 0; i < this.maxProjectiles; i++){
			this.projectileList[i] = new projectile(0,0, 1, true);
			this.projectileList[i].setSize(3.00,3.00);
			this.projectileList[i].kill();
		}
	}
	
	public void initItems(int maxItems, int maxItemImages){//Method for initializing item variables
		//Create item variables
		this.maxItems = maxItems;
		this.maxItemImages = maxItemImages;
		this.itemList = new item[this.maxItems];
		this.itemImage = new Image[this.maxItemImages];
		this.currentItemNum = 0;
	}
	
	public void initWindows(int maximumWindows){
		//Create windows
		this.maxWindows = maximumWindows;
		this.currentWindowNum = 0;
		this.windowList = new windowJ[this.maxWindows];
	}
	
	public void initExplosionParticles(int maxParticles){//Method for initalizing explosion particles
		this.maxExplosionParticles = maxParticles;
		this.explosionPList = new explosionP[this.maxExplosionParticles];
		for(int i=0; i < this.maxExplosionParticles; i++){
			this.explosionPList[i] = new explosionP(0,0);
			this.explosionPList[i].setSize(3.00,3.00);
			this.explosionPList[i].kill();
		}
	}
	
	public void setConsoleWin(String strWinName){//Method for defining the console window name
		this.consoleWin = strWinName;
	}
	
	public void setMainWin(String strWinName){//Method for defining the main window name
		this.mainWin = strWinName;	
	}
	
	public void forceImageLoad(){
		for(int i =0; i < this.currentImages; i++){
			try {
				this.tracker.waitForID(i);
			}
			catch (InterruptedException e) {
				this.addWindowMessage("Console", "Exception caught trying to load image: " + i, 500);
			}
		}
		this.gameLoaded = true;
	}
	
	//____________End Init Methods_______________
	
	
	//____________Begin Enemy Methods_______________
	public void addEnemy( double x, double y, int enemyType){//method for adding enemies to the game model
		
		if(this.currentEnemyNum < this.maxEnemies){
			this.enemyList[this.currentEnemyNum] = new enemy(x,y,enemyType);
			switch(this.enemyList[this.currentEnemyNum].enemyType){
			case 0:
				this.enemyList[this.currentEnemyNum].mType = 1;
				break;
			case 1:
				this.enemyList[this.currentEnemyNum].mType = 0;
				break;
			default:
				this.enemyList[this.currentEnemyNum].mType = 0;
				break;
			}
			this.currentEnemyNum++;			
		}
		
	}
	
	public void addEnemy( double x,double y, int enemyType, int life, int velocity, int theta, int width, int height){//method for adding enemies to the game model
		
		if(this.currentEnemyNum < this.maxEnemies){
			this.enemyList[this.currentEnemyNum] = new enemy(x,y,life,velocity,theta,enemyType);
			this.enemyList[this.currentEnemyNum].setSize(width, height);
			switch(this.enemyList[this.currentEnemyNum].enemyType){
			case 0:
				this.enemyList[this.currentEnemyNum].mType = 0;
				break;
			case 1:
				this.enemyList[this.currentEnemyNum].mType = 1;
				break;
			default:
				this.enemyList[this.currentEnemyNum].mType = 0;
				break;
			}
			this.currentEnemyNum++;
			
			
		}
	}
	
	public void addEnemyImage(Image img, int eType){//Method for adding an enemy image to the game model
		
		if(eType < this.maxEnemyImages){
			this.enemyImage[eType] =  img;	
			this.tracker.addImage(this.enemyImage[eType], this.currentImages);
			this.currentEnemyImage++;
			this.currentImages++;
		}
	}
	
	public double getEnemyX(int enemyNum){//method for obtaining enemy x-cooridinate
		
		if(enemyNum < this.currentEnemyNum){
			return this.enemyList[enemyNum].x;
		}
		else{return 0.00;}
		
	}
	public double getEnemyY(int enemyNum){//method for obtaining ememy y-coordinate
		
		if(enemyNum < this.currentEnemyNum){
			return this.enemyList[enemyNum].y;
		}
		else{return 0.00;}
	
	}
	
	public Image getEnemyImage(int enemyNum){//Method for obtaining enemy images from the game model
		
		if(enemyNum < this.currentEnemyNum){
			return enemyImage[this.enemyList[enemyNum].enemyType];	
		}
		else{ return null;}
	}
	
	public boolean enemyActive(int enemyNum){//Method to dertimine if an enemy is in an active state
			
		if(enemyNum < this.currentEnemyNum){
			if(this.enemyList[enemyNum].isAlive() && !this.enemyList[enemyNum].isAsleep){
				return true;
			}
			else{return false;}
		}
		else{return false;}
	}
	
	public int activeEnemies(){//Method for determining the number of active enemies
		int tmpNum=0;
		
		for(int i=0;i < this.currentEnemyNum; i++){
			if(this.enemyList[i].isAlive() && !this.enemyList[i].isAsleep){
				tmpNum++;
			}
		}
		return tmpNum;
	}
	
	public void enemyAction(){
		//Enemy AI(hahahah not even close!)
		for(int i=0; i < this.currentEnemyNum; i++){
			if(!this.enemyList[i].isAsleep && this.enemyList[i].isAlive()){
				if(this.enProjectilesOnScreen(5) < 3&& (this.getEnYoungestTime(5)/1000) >= .5){
					if(this.enemyList[i].x > (this.currentPlayer.x - 40) && this.enemyList[i].x < (this.currentPlayer.x + 160)){
						this.activateProjectile(this.enemyList[i].x, this.enemyList[i].y + this.enemyList[i].height, 20, 2, Color.green, true, true, 180, 5, 25);
					}
				}
			}
		}
	}
	
	//____________End Enemy Methods_______________
	
	//____________Begin Player Methods_______________
	public void addPlayer(double x, double y, int maxWpn){//Default method for adding a player to the game model
		
		currentPlayer = new player( x, y, maxWpn);
		
	}
	
	public void addPlayer(double x,double y, int life, int velocity, int theta, int maxWpn, int armor, double width, double height, int lives){//Method for adding a player to the game model
		
		this.currentPlayer = new player( x, y, life, velocity, theta, maxWpn, armor, lives);
		this.currentPlayer.setSize(width, height);
		
	}
	
	public void addPlayerImage(Image img, int imgType){//Method for adding a player image to the game model
		
		if(imgType < this.maxPlayerImages){
			this.playerImage[imgType] = img;
			this.tracker.addImage(this.playerImage[imgType], this.currentImages);
			this.currentPlayerImgNum++;
			this.currentImages++;
		}
	}
	
	public Image getPlayerImage(int imgType){//Method for retireving the player's image
		
		if(imgType < this.currentPlayerImgNum){
			return this.playerImage[imgType];
		}
		else{return null;}
	}
	
	public double getPlayerX(){//Method for deterimining the players X coordinate
		return this.currentPlayer.x;	
	}
	
	public double getPlayerY(){//Method for deterimining the players Y coordinate
		return this.currentPlayer.y;	
	}
	
	public double getPlayerWidth(){//Method for determining the players width
		return this.currentPlayer.width;	
	}
	
	public double getPlayerHeight(){//Method for determining the players height
		return this.currentPlayer.height;	
	}
	
	public int getPlayerImgType(){//Method for determinig the players current image type
		return this.currentPlayer.currentImageType;	
	}
	
	public void setPlayerVector( int angle, int velocity){//Method for setting the player's angle and velocity
		this.currentPlayer.theta = angle;
		this.currentPlayer.velocity = velocity;
	}
	//____________End Player Methods_______________
	
	//____________Begin Projectile Methods_______________
	public void activateProjectile( double x, double y, int dmg, int imgType, Color pColor, boolean pos){//Tries to activate a projectile
		
		for(int i=0; i < this.maxProjectiles; i++){
			if( !this.projectileList[i].isAlive()){
				this.projectileList[i].respawn((int)x, (int)y);
				this.projectileList[i].damage = dmg;
				this.projectileList[i].imageType = imgType;
				this.projectileList[i].projectileColor = pColor;
				this.projectileList[i].movePositive = pos;
				break;
			}
		}
	}
	
	public void activateProjectile( double x, double y, int dmg, int imgType, Color pColor, boolean pos, boolean enemyPrjctl, int angle, int moveType){//Tries to activate a projectile
		
		for(int i=0; i < this.maxProjectiles; i++){
			if( !this.projectileList[i].isAlive()){
				this.projectileList[i].respawn((int)x, (int)y);
				this.projectileList[i].damage = dmg;
				this.projectileList[i].imageType = imgType;
				this.projectileList[i].projectileColor = pColor;
				this.projectileList[i].movePositive = pos;
				this.projectileList[i].theta = angle;
				this.projectileList[i].velocity = 70;
				this.projectileList[i].enemyProjectile = enemyPrjctl;
				this.projectileList[i].mType = moveType;
				if(this.projectileList[i].mType == 3){
					this.projectileList[i].theta = (int)x;
					this.projectileList[i].phi = (int)y;
				}
				break;
			}
		}
	}
	
	public void activateProjectile( double x, double y, int dmg, int imgType, Color pColor, boolean pos, boolean enemyPrjctl, int angle, int moveType, int vel){//Tries to activate a projectile
		
		for(int i=0; i < this.maxProjectiles; i++){
			if( !this.projectileList[i].isAlive()){
				this.projectileList[i].respawn((int)x, (int)y);
				this.projectileList[i].damage = dmg;
				this.projectileList[i].imageType = imgType;
				this.projectileList[i].projectileColor = pColor;
				this.projectileList[i].movePositive = pos;
				this.projectileList[i].theta = angle;
				this.projectileList[i].velocity = vel;
				this.projectileList[i].enemyProjectile = enemyPrjctl;
				this.projectileList[i].mType = moveType;
				if(this.projectileList[i].mType == 3){
					this.projectileList[i].theta = (int)x;
					this.projectileList[i].phi = (int)y;
				}
				break;
			}
		}
	}
	
	public void activateProjectileCloud( int totalNum, double x, double y, int dmg, int imgType, Color pColor, boolean pos, boolean enemyPrjctl, int moveType){//Tries to activate a projectile
		
		for(int j=0; j < totalNum; j++){
			for(int i=0; i < this.maxProjectiles; i++){
				if( !this.projectileList[i].isAlive()){
					this.projectileList[i].respawn((int)x, (int)y);
					this.projectileList[i].damage = dmg;
					this.projectileList[i].imageType = imgType;
					this.projectileList[i].projectileColor = pColor;
					this.projectileList[i].movePositive = pos;
					this.projectileList[i].enemyProjectile = enemyPrjctl;
					this.projectileList[i].mType = moveType;
					if(this.projectileList[i].mType == 3){
						this.projectileList[i].theta = (int)x;
						this.projectileList[i].phi = (int)y;
					}
					this.projectileList[i].linearMove(5);
					this.projectileList[i].velocity = 10;
					break;
				}
			}
		}	
	
	}
	
	public double getProjectileX(int projectileNum){//Method for determining a certain projectiles X coordinate
	
		if(projectileNum < this.maxProjectiles){
			return this.projectileList[projectileNum].x;	
		}
		else{ return 0.00;}
	}
	
	public double getProjectileY(int projectileNum){//Method for determining a certain projectiles Y coordinate
	
		if(projectileNum < this.maxProjectiles){
			return this.projectileList[projectileNum].y;	
		}
		else{ return 0.00;}
	}
	
	public double getProjectileSizeX(int projectileNum){//Method for retrieving projectile's x-coordinate size
		
		if(projectileNum < this.maxProjectiles){
			return this.projectileList[projectileNum].width;	
		}
		else{ return 0.00;}
	}
	
	public double getProjectileSizeY(int projectileNum){//Method for retrieving projectile's y-coordinate size
		
		if(projectileNum < this.maxProjectiles){
			return this.projectileList[projectileNum].height;
		}
		else{ return 0.00;}
	}
	
	public Color getProjectileColor(int projectileNum){//Method for retrieving a projectile's color
		if(projectileNum < this.maxProjectiles){
			return this.projectileList[projectileNum].projectileColor;	
		}
		else{return Color.white;}
	}
	
	public boolean projectileActive( int projectileNum){//Method for determining whether the projectile is active
		
		if(projectileNum < this.maxProjectiles){
			return this.projectileList[projectileNum].isAlive();
		}
		else{return false;}
	}
	
	public void addProjectileImage( Image img, int imageType){//Method for adding projectile images
		
		if( imageType < this.maxProjectileImages){
			this.projectileImage[imageType] = img;
			this.tracker.addImage(this.projectileImage[imageType], this.currentImages);
			this.currentImages++;
		}
	}
	
	public Image getProjectileImage( int imageType){//Method for retieving projectile images
		
		if(imageType < this.maxProjectileImages){
			return this.projectileImage[imageType];
		}
		else{ return null;}
	}
	
	public int getProjectileImageType(int projectileNum){//Method for retrieving projectile image type
		
		if(projectileNum < this.maxProjectiles){
			return this.projectileList[projectileNum].imageType;	
		}
		else{return 0;}
	}
	
	public int enProjectilesOnScreen(int moveType){//Determines and returns the total number of projectiles on screen of a certain type
		int tmpCount = 0;
		for(int i=0; i < this.maxProjectiles; i++){
			if(projectileActive(i) && this.projectileList[i].enemyProjectile){
				if(this.projectileList[i].mType == moveType){
					tmpCount++;	
				}
			}
		}
		return tmpCount;
	}
	
	public int projectilesOnScreen(int moveType){//Determines and returns the total number of projectiles on screen of a certain type
		int tmpCount = 0;
		for(int i=0; i < this.maxProjectiles; i++){
			if(projectileActive(i) && !this.projectileList[i].enemyProjectile){
				if(this.projectileList[i].mType == moveType){
					tmpCount++;	
				}
			}
		}
		return tmpCount;
	}
	
	public double getYoungestTime(int moveType){//Determines and returns the total number of projectiles on screen of a certain type
		double tmpTime = 0.00;
		boolean bFirst = true;
		for(int i=0; i < this.maxProjectiles; i++){
			if(projectileActive(i) && !this.projectileList[i].enemyProjectile){
				if(this.projectileList[i].mType == moveType){
					if(bFirst){
						tmpTime = this.projectileList[i].oldTime;
						bFirst = false;
					}
					if(this.projectileList[i].oldTime > tmpTime){
						tmpTime = this.projectileList[i].oldTime;
					}
				}
			}
		}
		if(bFirst){
			tmpTime = 1500;
			bFirst = false;
		}
		else{
			tmpTime = System.currentTimeMillis() - tmpTime;	
		}
		
		return tmpTime;
	}
	
	public double getEnYoungestTime(int moveType){//Determines and returns the total number of projectiles on screen of a certain type
		double tmpTime = 0.00;
		boolean bFirst = true;
		for(int i=0; i < this.maxProjectiles; i++){
			if(projectileActive(i) && this.projectileList[i].enemyProjectile){
				if(this.projectileList[i].mType == moveType){
					if(bFirst){
						tmpTime = this.projectileList[i].oldTime;
						bFirst = false;
					}
					if(this.projectileList[i].oldTime > tmpTime){
						tmpTime = this.projectileList[i].oldTime;
					}
				}
			}
		}
		if(bFirst){
			tmpTime = 1500;
			bFirst = false;
		}
		else{
			tmpTime = System.currentTimeMillis() - tmpTime;	
		}
		
		return tmpTime;
	}
	
	//____________End Projectile Methods_______________
	
	//____________Begin Explosion Particle Methods_______________
	public void activateExplosion( int totalNum, double x, double y){//Tries to activate an explosion
		
		for(int j=0; j < totalNum; j++){
			for(int i=0; i < this.maxExplosionParticles; i++){
				if( !this.explosionPList[i].isAlive()){
					this.explosionPList[i].respawn((int)x, (int)y);
					this.explosionPList[i].explosionPColor = getExplosionColor();
					this.explosionPList[i].mType = 4;
					
					//this.explosionPList[i].velocity = 100;
					break;
				}
			}
		}	
	
	}
	
	public void activateExplosion( int totalNum, double x, double y, Color c1){//Tries to activate an explosion
		
		for(int j=0; j < totalNum; j++){
			for(int i=0; i < this.maxExplosionParticles; i++){
				if( !this.explosionPList[i].isAlive()){
					this.explosionPList[i].respawn((int)x, (int)y);
					this.explosionPList[i].explosionPColor = c1;
					this.explosionPList[i].mType = 4;
					
					//this.explosionPList[i].velocity = 100;
					break;
				}
			}
		}	
	
	}
	
	private Color getExplosionColor(){
		int TmpNum;
		TmpNum = (int)(Math.random()*5);
		switch(TmpNum){
		case 0:
			//return Color.darkGray;
			return Color.lightGray;
		case 1:
			return Color.blue;
			//return Color.red;
		case 2:
			//return Color.orange;
			return Color.cyan;
		case 3:
			//return Color.orange;
			return Color.cyan;
		case 4:
			return Color.darkGray;
		default:
			//return Color.darkGray;
			return Color.lightGray;
		}
	}
	
	//____________End Explosion Particle Methods_______________
	
	//____________Begin Item Methods_______________
	public void addItem(double x, double y, int imgType, int fxType, int itemType, int width, int height, String itemName){//Method for adding items
		
		if(this.currentItemNum < this.maxItems){
			this.itemList[this.currentItemNum] = new item(x, y, imgType, fxType, itemType, itemName);
			this.itemList[this.currentItemNum].width = width;
			this.itemList[this.currentItemNum].height = height;
			this.itemList[this.currentItemNum].kill();
			this.currentItemNum++;
		}
	}
	
	public void addItemImage(Image img, int imgType){//Method for adding items
		
		if(imgType < this.maxItemImages){
			this.itemImage[imgType] = img;			
		}
	}
	
	private void activateItem(double x, double y, int itemType){//Method for activating items
		
		for(int i=0; i < this.maxItems; i++){
			if(itemType == this.itemList[i].itemType && !this.itemList[i].isAlive()){
				this.itemList[i].respawn((int)x,(int)y);
				this.itemList[i].theta = 180;
				this.itemList[i].velocity = 2;
				this.itemList[i].mType = 0;				
			}
		}
	}
	
	public Image getItemImage(int imgType){
		
		if(imgType < this.maxItemImages){
			return this.itemImage[imgType];	
		}
		else{return null;}
	
	}
	
	public double getItemX(int itemType){
		
		if(itemType < this.maxItems){
			return this.itemList[itemType].x;
		}
		else{ return 0.00;}
	}
	
	public double getItemY(int itemType){
		
		if(itemType < this.maxItems){
			return this.itemList[itemType].y;
		}
		else{ return 0.00;}
	}
	
	public boolean itemActive(int itemType){
		
		if(itemType < this.maxItems){
			return this.itemList[itemType].isAlive();
		}
		else{return false;}
	}
	
	private void addRandomItem(double x, double y){//Method for adding random item to the game(doesn't always add random item)
		int tmp = (int)(Math.random()*100);
		if(tmp < 10){
			tmp = (int)(Math.random()*this.maxItems);
			activateItem(x,y, tmp);	
		}
	}
	//____________End Item Methods_______________
	
	//____________Begin Window Methods_______________
	public void addWindow(int x, int y, Font windowFont, Color textColor, String windowName){//Method for adding text window to the game model
		if(this.currentWindowNum < this.maxWindows){
			this.windowList[this.currentWindowNum] = new windowJ(x,y,windowFont, textColor, windowName);
			this.currentWindowNum++;
		}
	}
	
	public void addWindow(int x, int y, Font windowFont, Color textColor, String windowName, Color BGColor, int width, int height){//Method for adding text window to the game model
		if(this.currentWindowNum < this.maxWindows){
			this.windowList[this.currentWindowNum] = new windowJ(x,y,windowFont, textColor, windowName);
			this.windowList[this.currentWindowNum].bgColor = BGColor;
			this.windowList[this.currentWindowNum].width = width;
			this.windowList[this.currentWindowNum].height = height;
			this.currentWindowNum++;
		}
	}
	
	public void addWindow(int x, int y, Font windowFont, Color textColor, String windowName, Image BGImage){//Method for adding text window to the game model
		if(this.currentWindowNum < this.maxWindows){
			this.windowList[this.currentWindowNum] = new windowJ(x,y,windowFont, textColor, windowName);
			this.windowList[this.currentWindowNum].bgImage = BGImage;
			this.currentWindowNum++;
		}
	}
	
	public void addWindowMessage(String windowName, String msg, int tick){//Method for adding message a game model's window
		
		for(int i=0; i < this.currentWindowNum; i ++){
			
			if(this.windowList[i].name.equalsIgnoreCase(windowName)){
				this.windowList[i].addMessage(msg, tick);	
			}
			
		}
	}
	
	public windowJ getWindow(int winNum){//Method for return a game window object
		
		if(winNum < this.maxWindows){
			return this.windowList[winNum];	
		}
		else{return null;}
		
	}
	//____________End Window Methods_______________
	
	public int getScore(){//Method for retrieving the score
		return this.score;	
	}
	
	public void addScore(int increment){//Method for adding points to the score
		this.score = this.score + increment;	
	}
	
	public void collisionDet(){//Method for detecting and handling collisions within the game model
		//Check for player collision with enemies
		for(int i=0; i < this.currentEnemyNum; i++){
			//Check if enemy is alive and not sleeping
			if(this.enemyList[i].isAlive() && !this.enemyList[i].isAsleep){
				//If collision occured apply damage and kill enemy
				if(this.enemyList[i].collided(this.currentPlayer)){
					this.enemyList[i].kill();
					this.currentPlayer.age(5);
				}
			}
		}
		
		//Check for collsions with projectiles
		for(int i=0; i < this.maxProjectiles; i++){
			if(this.projectileList[i].isAlive()){
				//if this is an enemy projectile then check if player was hit
				if(this.projectileList[i].enemyProjectile){
					//If collision occured apply damage and kill projectile
					if(this.projectileList[i].collided(this.currentPlayer)){
						this.currentPlayer.age(this.projectileList[i].damage);
						this.projectileList[i].kill();
						this.activateExplosion(20, this.projectileList[i].x + (this.projectileList[i].width/2), this.projectileList[i].y + (this.projectileList[i].height/2), Color.gray);
					}
				}
				//If this is the player's projectile check if the enemies were hit
				else{
					//Loop through enemies and check for collisions
					for(int j=0; j < this.currentEnemyNum; j++){
						//Check if enemy is alive and not sleeping
						if(this.enemyList[j].isAlive() && !this.enemyList[j].isAsleep){
							//If collision occured apply damage and kill projectile
							if(this.projectileList[i].collided(this.enemyList[j])){
								this.enemyList[j].age(this.projectileList[i].damage);
								this.projectileList[i].kill();
								//If the enemy has died allow for random item
								//And cause an explosion
								if(!this.enemyList[j].isAlive()){
									this.activateExplosion(50, this.enemyList[j].x, this.enemyList[j].y, Color.white);
									this.addScore(10);
									//this.addRandomItem(this.enemyList[j].x, this.enemyList[j].y);
								}
							}
						}
					}
					//Check to see if the player has collided with their own projectile
					//If collision occured apply damage and kill projectile
					if(this.projectileList[i].collided(this.currentPlayer)){
						this.currentPlayer.age(10);
						this.projectileList[i].kill();
						this.activateExplosion(10, this.projectileList[i].x + (this.projectileList[i].width/2), this.projectileList[i].y + (this.projectileList[i].height/2), Color.gray);
					}
				}
			}
		}
		
		//Check for item collisions with player
		for(int i=0; i < this.maxItems; i++){
			if(this.itemList[i].isAlive()){
				if(this.itemList[i].collided(this.currentPlayer)){
					this.currentPlayer.currentWeapon = this.itemList[i].itemType;
					addWindowMessage( this.mainWin, "Acquired " + this.itemList[i].itemName, 200);
					this.itemList[i].kill();
				}
			}
		}
		
	}
	
	public void checkBounds(int xBoundary, int yBoundary){//Method for checking all game unit's boundaries
		//Loop through all enemies
		for(int i=0; i < this.currentEnemyNum; i++){
			//Check to see if they are active
			if(this.enemyList[i].isAlive() && !this.enemyList[i].isAsleep){
				//Check boundaries and kill all wrong doers
				if((this.enemyList[i].x + this.enemyList[i].width/2)< 0 || (this.enemyList[i].x - this.enemyList[i].width/2) > xBoundary || (this.enemyList[i].y + this.enemyList[i].height/2) < 0 || (this.enemyList[i].y - this.enemyList[i].height/2) > yBoundary){
					this.enemyList[i].kill();	
				}
			}
		}
		//Loop through all projectiles
		for(int i=0; i < this.maxProjectiles; i++){
			if(this.projectileList[i].isAlive()){
				if(this.projectileList[i].x < 0 || this.projectileList[i].x > xBoundary || this.projectileList[i].y < 0 || this.projectileList[i].y > yBoundary){
					this.projectileList[i].kill();	
				}
			}
		}
		
		//Check Item bounds
		for(int i=0; i < this.maxItems; i++){
			if(this.itemList[i].isAlive()){
				if(this.itemList[i].x > xBoundary || this.itemList[i].x < 0 || this.itemList[i].y > yBoundary || this.itemList[i].y < 0){
					this.itemList[i].kill();	
				}
			}
		}
		
		//Check Explosion particle bounds
		for(int i=0; i < this.maxExplosionParticles; i++){
			if(this.explosionPList[i].isAlive()){
				if(this.explosionPList[i].x > xBoundary ||this.explosionPList[i].x < 0 || this.explosionPList[i].y > yBoundary || this.explosionPList[i].y < 0){
					this.explosionPList[i].kill();	
				}
			}
		}
		
		//Check player bounds
		if(this.currentPlayer.x < 0){this.currentPlayer.x = 0;}
		if(this.currentPlayer.x > xBoundary-this.currentPlayer.width){this.currentPlayer.x = xBoundary-this.currentPlayer.width;}
		if(this.currentPlayer.y < 0){this.currentPlayer.y = 0;}
		if(this.currentPlayer.y > yBoundary-this.currentPlayer.height){this.currentPlayer.y = yBoundary-this.currentPlayer.height;}
		
	}
	
	public void moveUnits(){//Method for moving all game objects
		//Loop through all enemies
		for(int i=0; i < this.currentEnemyNum; i++){
			if(this.enemyList[i].isAlive() && !this.enemyList[i].isAsleep){
				this.enemyList[i].move(false);
			}
		}
		//move player
		//this.currentPlayer.move();
		
		//Loop through all projectiles
		for(int i=0 ; i < this.maxProjectiles; i++){
			if(this.projectileList[i].isAlive()){
				this.projectileList[i].move(this.projectileList[i].movePositive);
				
			}
		}
		//Move Items
		for(int i=0; i < this.maxItems; i++){
			if(this.itemList[i].isAlive()){
				this.itemList[i].move();	
			}
		}
		//Move Explosoin particles
		for(int i=0; i < this.maxExplosionParticles; i++){
			if(this.explosionPList[i].isAlive()){
				this.explosionPList[i].move();
			}
		}
	}
	
	public void respawnUnits(int xBoundary, int yBoundary){//Method for respawning all game units
		//Loop through all enemies
		for(int i=0; i < this.currentEnemyNum; i++){
			if(!this.enemyList[i].isAlive() && !this.enemyList[i].isAsleep){
				this.enemyList[i].respawn(xBoundary, (int)(Math.random()*(yBoundary-150)));
				this.enemyList[i].sleep(1700);
			}
		}
	}
	
	public void age(){//Method for aging game model properties
		//Age windows
		for(int i =0; i < this.maxWindows; i++){
			this.windowList[i].age();
		}
		//Age enemies(tick them)
		for(int i=0; i< this.currentEnemyNum; i++){
			if(this.enemyList[i].isAlive()){
				this.enemyList[i].tick(1);
			}
		}
		//Age explosion particles
		for(int i=0; i < this.maxExplosionParticles; i++){
			if(this.explosionPList[i].isAlive()){
				this.explosionPList[i].age();
			}
		}
	}
	public void killAll(){//Method for aging game model properties
		//Kill enemies
		for(int i=0; i< this.currentEnemyNum; i++){
			if(this.enemyList[i].isAlive()){
				this.enemyList[i].kill();
			}
		}
		//Kill explosion particles
		for(int i=0; i < this.maxExplosionParticles; i++){
			if(this.explosionPList[i].isAlive()){
				this.explosionPList[i].kill();
			}
		}
		//Kill projectiles
		for(int i=0 ; i < this.maxProjectiles; i++){
			if(this.projectileList[i].isAlive()){
				this.projectileList[i].kill();
				
			}
		}
		//Kill Items
		for(int i=0; i < this.maxItems; i++){
			if(this.itemList[i].isAlive()){
				this.itemList[i].kill();
			}
		}
	}
}
