import java.awt.Color;

public class particle{
			
	public int life, velocity, theta, phi, mType;
	public double x, y, z, width, height, depth, oldX, oldY, oldTime, x0, y0;
	public Color color;
	
	private boolean is3d;
	private static int j;
	private static double Sinus[], Cosinus[], deg2rad, alpha;
	
	static{
		deg2rad = Math.PI/180;
		Sinus = new double[361];
		Cosinus = new double[361];
		for(j=0; j < 361; j++){
			Sinus[j] = Math.sin(j*deg2rad);
			Cosinus[j] = Math.cos(j*deg2rad);
		}
	}
	
	particle(double x, double y){ //Default 2d constructor
		this.is3d = false;
		this.x = x;
		this.y = y;
		this.life = (int)(Math.random() * 100);
		this.velocity = (int)(Math.random() * 10)+1;
		//Note this random angle generation will only produce angles
		//of a certain set of degrees.
		this.theta = (int)(Math.random() * 360);
		this.mType = 0;
		this.width = 1;
		this.height = 1;
		
	}
	
	particle(double x,double y, int life, int velocity, int theta){ //2d Constructor
		this.is3d = false;
		this.x = x;
		this.y = y;
		this.life = life;
		this.velocity = velocity;
		this.theta = theta;
		this.mType = 0;
		this.width = 1;
		this.height = 1;
		
	}
	
	particle(double x, double y, double z){ //Default 3d constructor
		this.is3d = true;
		this.x = x;
		this.y = y;
		this.z = z;
		this.life = (int)(Math.random() * 100);
		this.velocity = (int)(Math.random() * 10)+1;
		//Note this random angle generation will only produce angles
		//of a certain set of degrees.
		this.theta = (int)(Math.random() * 360);
		this.phi = (int)(Math.random() * 360);
		this.mType = 0;
		this.width = 1;
		this.height = 1;
		this.depth = 1;
		
	}
	
	particle(double x, double y, double z, int life, int velocity, int theta, int phi){ //3d constructor
		this.is3d = true;
		this.x = x;
		this.y = y;
		this.z = z;
		this.life = life;
		this.velocity = velocity;
		this.theta = theta;
		this.phi = phi;
		this.mType = 0;
		this.width = 1;
		this.height = 1;
		this.depth = 1;
		
	}
	
	public final void setSize(double width, double height){
		this.width = width;
		this.height = height;
	}
	
	public final void setSize(double width, double height, double depth){
		this.width = width;
		this.height = height;
		this.depth = depth;
	}
	
	public void age(){
		this.life--;
	}
	
	public void age(int decrement){
		this.life = this.life - decrement;
		if(this.life < 0){this.life = 0;}
	}
	
	public final void kill(){
		this.life = 0;
	}
	
	public boolean isAlive(){
		boolean alive = false;
		if(this.life > 0){alive = true;}
		return alive;
	}
	
	public final void linearMove(){
		if(this.is3d){
			//If the particle is 3d do 3d calculations
			alpha = this.velocity * Cosinus[this.phi];
			this.y -= this.velocity * Sinus[this.phi];
			this.x += alpha * Sinus[this.theta];
			this.z += alpha * Cosinus[this.theta];
		}
		else{
			this.oldX = this.x;
			this.oldY = this.y;
			//If the particle is 2d do 2d calculations
			this.x += this.velocity * Cosinus[this.theta];
			this.y -= this.velocity * Sinus[this.theta];
		}
	}
	
	public final void linearMove(int amount){
		if(this.is3d){
			//If the particle is 3d do 3d calculations
			alpha = this.velocity * Cosinus[this.phi];
			for(j=0; j < amount; j++){				
				this.y -= this.velocity * Sinus[this.phi];
				this.x += alpha * Sinus[this.theta];
				this.z += alpha * Cosinus[this.theta];
			}
		}
		else{
			//If the particle is 2d do 2d calculations
			for(j=0; j < amount; j++){				
				this.oldX = this.x;
				this.oldY = this.y;
				this.x += this.velocity * Cosinus[this.theta];
				this.y -= this.velocity * Sinus[this.theta];
			}
		}
	}
	
	public final void linearMoveReverse(int amount){
		if(this.is3d){
			//If the particle is 3d do 3d calculations
			alpha = this.velocity * Cosinus[this.phi];
			for(j=0; j < amount; j++){				
				this.y += this.velocity * Sinus[this.phi];
				this.x -= alpha * Sinus[this.theta];
				this.z -= alpha * Cosinus[this.theta];
			}
		}
		else{
			//If the particle is 2d do 2d calculations
			for(j=0; j < amount; j++){				
				this.oldX = this.x;
				this.oldY = this.y;
				this.x -= this.velocity * Cosinus[this.theta];
				this.y += this.velocity * Sinus[this.theta];
			}
		}
	}
	
	public final void mobiusWave(){
		this.x++;
		this.theta++;
		if(this.theta > 360){this.theta = 0;}
		this.y += Sinus[this.theta];	
	}
	
	public final void mobiusWave(boolean positive){
		if(positive){this.x++;}
		else{this.x--;}
		this.theta++;
		if(this.theta > 360){this.theta = 0;}
		this.y += Sinus[this.theta];	
	}
	
	public final void sinWave(){
		this.x += 2;
		this.y = 2*Math.sin(this.x)+this.y;	
	}
	
	public final void sinWave(boolean positive){
		if(positive){this.x +=2;}
		else{this.x -=2;}
		this.y = 2*Math.sin(this.x)+this.y;	
	}
	
	public final void powerCurve(){
		this.y = 3*Math.sqrt(this.x-this.theta)+this.phi;
		this.x = this.x+3;
	}
	
	public final void gravMove(double time){
		double currentTime;
		currentTime = (time - this.oldTime)/1000;
		this.oldX = this.x;
		this.oldY = this.y;
		this.x = this.x0 + ((this.velocity * Cosinus[this.theta])* currentTime);
		this.y = this.y0 + (((this.velocity * Sinus[this.theta])* currentTime) + (9.81 *(currentTime*currentTime))/2);
				
	}
	
	public final void gravDropMove(double time){
		double currentTime;
		currentTime = (time - this.oldTime)/1000;
		this.oldX = this.x;
		this.oldY = this.y;
		this.x = this.x0 - (this.velocity * currentTime);
		this.y = this.y0 + ((9.81 *(currentTime*currentTime))/2);
	}
	
	public final void move(){
		switch(this.mType){
		case 0:
			this.linearMove();
			break;
		case 1:
			this.mobiusWave();
			break;
		case 2:
			this.sinWave();
			break;
		case 3:
			this.powerCurve();
			break;
		case 4:
			this.gravMove(System.currentTimeMillis());
			break;
		case 5:
			this.gravDropMove(System.currentTimeMillis());
			break;
		default:
			this.linearMove();
		}
	}
	
	public final void move(boolean positive){
		switch(this.mType){
		case 0:
			this.linearMove();
			break;
		case 1:
			this.mobiusWave(positive);
			break;
		case 2:
			this.sinWave(positive);
			break;
		case 3:
			this.powerCurve();
			break;
		case 4:
			this.gravMove(System.currentTimeMillis());
			break;
		case 5:
			this.gravDropMove(System.currentTimeMillis());
			break;
		default:
			this.linearMove();
		}
	}
	

	
	public final void rotate(int x2, int y2, int angle){
		double x1, y1;
		x1 = ((this.x-x2)* Cosinus[angle] - (this.y-y2)* Sinus[angle])+x2;
		y1 = ((this.x-x2)* Sinus[angle] + (this.y-y2)* Cosinus[angle])+y2;
		this.x = x1;
		this.y = y1;
		
	}
	
	public final void thetaAdd(int amount){
		this.theta += amount;
		if(this.theta > 360){
			this.theta = this.theta - 360;
		}
		if(this.theta < 0){
			this.theta = 360 + this.theta;
		}
	}
	public final void phiAdd(int amount){
		this.phi = this.phi + amount;
		if(this.phi > 360){
			this.phi = this.phi - 360;
		}
		if(this.phi < 0){
			this.phi = 360 + this.phi;
		}
	}
	
	public void respawn(int x, int y){
		this.is3d = false;
		this.x = x;
		this.y = y;
		this.oldX = x;
		this.oldY = y;
		this.x0 = x;
		this.y0 = y;
		this.life = (int)(Math.random() * 25)+1;
		this.velocity = (int)(Math.random() * 50)+1;
		//Note this random angle generation will only produce angles
		//of a certain set of degrees.
		this.theta = (int)(Math.random() * 360);
		//Set Activation time
		this.oldTime = System.currentTimeMillis();
	}
	
	public void respawn(int x, int y, int z){
		this.is3d = true;
		this.x = x;
		this.y = y;
		this.z = z;
		this.life = (int)(Math.random() * 100)+1;
		this.velocity = (int)(Math.random() * 10)+1;
		//Note this random angle generation will only produce angles
		//of a certain set of degrees.
		this.theta = (int)(Math.random() * 360);
		this.phi = (int)(Math.random() * 360);
		//Set Activation time
		this.oldTime = System.currentTimeMillis();
	}
	
	public boolean collided(particle p){
		if((this.x > p.x && this.x < p.x  + p.width) || (this.x + this.width > p.x && this.x + this.width < p.x + p.width)){
			if((this.y > p.y && this.y < p.y + p.height) || (this.y + this.height > p.y && this.y + this.height < p.y + p.height)){
				return true;
			}
			else{return false;}
		}
		else{return false;}
	}
	

}